<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories\ProdutoRepository;

class ProdutoService {

    protected $produtoRepository;

    public function __construct(ProdutoRepository $produtoRepository) {
        $this->produtoRepository = $produtoRepository;
    }

    public function getNextId($cdprodnivante, $nrorg) {
        $idRow = $this->produtoRepository->getMaxId($cdprodnivante, $nrorg);
        $id = $idRow[0]['CDARVPROD'];
        return !is_null($id) ? ++$id : null;
    }

    public function getProdutoPai($cdprodnivante, $nrorg) {
        $result = $this->produtoRepository->getProdutoPai($cdprodnivante, $nrorg);
        return !empty($result) ? $result : array('');
    }

    public function checaFilhos($nrorg, $cdproduto){
        $result = $this->produtoRepository->checaFilhos($nrorg, $cdproduto);
        return !empty($result) ? true : false;
    }

    public function validaCodigo($cdarvprod, $nrorg){
    	$validacao = $this->produtoRepository->validaCodigo($cdarvprod, $nrorg);
    	return $validacao;
    }

    public function validaCodigoBarras($cdbarproduto){
        $validacao = $this->produtoRepository->validaCodigoBarras($cdbarproduto);
        return $validacao;
    }

    public function getCdpictprod($params) {
        return $this->produtoRepository->getCdpictprod($params);
    }

    public function getUltNvProd($params){
        return $this->produtoRepository->getUltNvProd($params);
    }
} 